// WIDGET WEATHER 2.0 - BASE WIDGET
// Based on UniAW7 from Ian Nicoll & Dacal

// MAIN VARIABLES
var updateFileTimer = "";
var updateTimer = 0;
var refreshTimer;
var obj = {};
var xmlnumber = "";
var where = "";
var whereOld = "";
var time_to_change_wall;
var dayhour;
var nighthour;
var ampm = false;
var Distance_In_Miles = false;
var Inches_Of_Mercury = false;
var UTC = 0;
if (lang == "am" || lang == "en") { var add_suffix = true; }
 
// SET A TIME OUT FOR ALL AJAX REQUEST AND DESACTIVATE THE CACHE
$.ajaxSetup({timeout: 8000, cache: false}); 

function init() {
	// TO START WITH ALL TAB CLOSED
	if (AllTabsClosedAtStart) {	touchCurrent(); }
	document.getElementById("TouchLayerCurrent").innerHTML= currenttext;
    document.getElementById("TouchLayerDayForecast").innerHTML= dayforecasttext;
    document.getElementById("TouchLayerHourlyForecast").innerHTML= hourlyforecasttext;
	document.getElementById("ExtraLocationTitle").innerHTML= extralocationtext;	
	// SHOW BACKGROUND
	if (ShowBackground == true) { document.getElementById("Layer").style.display = "block"; }
	if (ShowLogo == true) { document.getElementById("Logo").style.display = "block"; }
	
	// LAUNCH CLOCK FUNCTON
	updateClock();
    setInterval(updateClock, 1000);
	
	// LAUNCH TOUCH FUNCTION
	StartTouch();

	// LAUNCH WEATHER FUNCTION
	updateWeather_XML();
}

function updateClock() {
	currentTime = new Date();
	if (UTC != 0) { currentTime = new Date(currentTime.getTime() + UTC*3600*1000); }
	var currentHours = currentTime.getHours();
	var currentMinutes = currentTime.getMinutes() < 10 ? '0' + currentTime.getMinutes() : currentTime.getMinutes();
	var currentSeconds = currentTime.getSeconds() < 10 ? '0' + currentTime.getSeconds() : currentTime.getSeconds();
	time_to_change_wall = currentHours + currentMinutes/60;
	timeOfDay = ( currentHours < 12 ) ? "AM" : "PM";

	if (ampm == false) {
		timeOfDay = "";
		currentHours = ( currentHours < 10 ? "0" : "" ) + currentHours;
		currentTimeString = currentHours + ":" + currentMinutes;
	} else {
		currentHours = ( currentHours > 12 ) ? currentHours - 12 : currentHours;
		currentHours = ( currentHours == 0 ) ? 12 : currentHours;
		currentTimeString = currentHours + ":" + currentMinutes + " " + timeOfDay;
	}

	document.getElementById("calendar").innerHTML = Calendar(currentTime);
	document.getElementById("clock").innerHTML = (ampm == true) ? currentHours + ":" + currentMinutes + " " + timeOfDay : currentHours + ":" + currentMinutes;
}

function Calendar(stringTime) {
	if (lang == "am") { return days[stringTime.getDay()] + ", " + months[stringTime.getMonth()].toLowerCase() + " " + Suffix(stringTime.getDate()); }
	else if (lang == "en") { return days[stringTime.getDay()] + " " + Suffix(stringTime.getDate()) + " " + months[stringTime.getMonth()].toLowerCase(); }
	else { return days[stringTime.getDay()] + " " + stringTime.getDate() + " " + months[stringTime.getMonth()].toLowerCase(); }
}

function Suffix(tmpDate) {
	switch (tmpDate) {
		case 1:
		case 21:
		case 31:
			return tmpDate + "st";
		break;
		case 2: 
		case 22:
			return tmpDate + "nd";
		break;
		case 3:
		case 23:
			return tmpDate + "rd";
		break;
		default:
			return tmpDate + "th";
		break;
	}
}

function dealWithWeather(obj) {

	// DEFINE ALL UNITS
	if (Distance_In_Miles == true) {
		var convertD = 0.621371192;
		var visibilityunit = "mi.";
		var windspeedunit = "mph";
	} else {
		var convertD = 1;
		var visibilityunit = "km";
		var windspeedunit = "km/h";
	}

	if (Inches_Of_Mercury == true) {
		var convertP = 33.8638864;
		var pressureunit = "inHg";
	} else {
		var convertP = 1;
		var pressureunit = "mb";
	}

	if (obj.celsius == "YES") { var Unit = "C" } else { var Unit = "F" }
	
	if (Show_Degree == true) {
		if (ShowTempUnit == true) { var tempUnit = "&#176;" + Unit; } else { var tempUnit =  "&#176;"; }
	} else {
		if (ShowTempUnit == true) { var tempUnit = " " + Unit; } else { var tempUnit =	""; }	
	}

	// COORDINATES
	if (obj.latitude < 0) { textLat = obj.latitude.toFixed(2) + "\u00B0" + "S"; }
	else if (obj.latitude > 0){ textLat = obj.latitude.toFixed(2) + "\u00B0" + "N"; }
	else { textLat = obj.latitude.toFixed(2) + "\u00B0"; }
	if (obj.longitude < 0) { textLong = obj.longitude.toFixed(2) + "\u00B0" + "W"; }
	else if (obj.longitude > 0) { textLong = obj.longitude.toFixed(2) + "\u00B0" + "E"; }
	else { textLong = obj.longitude.toFixed(2) + "\u00B0"; }
	document.getElementById("coordinates").innerHTML = textLat + " " + textLong;

	// SUNRISE & SUNSET
	var sunriseh = parseInt(obj.sunrise[0].split(':')[0]);
	var sunrisem = obj.sunrise[0].split(':')[1];
	var sunseth = parseInt(obj.sunset[0].split(':')[0]);
	var sunsetm = obj.sunset[0].split(':')[1];
	dayhour = sunriseh + parseInt(sunrisem)/60;
	nighthour = sunseth + parseInt(sunsetm)/60;
	DurationOfDay = nighthour - dayhour;
	DurationOfNight = 24 - DurationOfDay;
				
	// DAY OR NIGHT ?
	if ((time_to_change_wall < dayhour) || (time_to_change_wall >= nighthour)) { where = "night"; } else { where = "day"; }
	
	// CITY INFORMATION
	var cityname = obj.name;
	switch (UseExtraLocation) {
		case "city":
			if ((obj.extraLocCity != "null") && (obj.extraLocCity != "") && (typeof(obj.extraLocCity) != "undefined")) { cityname = obj.extraLocCity; }
		break;
		case "neighborhood":
			if ((obj.extraLocNeighborhood != "null") && (obj.extraLocNeighborhood != "") && (typeof(obj.extraLocNeighborhood) != "undefined")) { cityname = obj.extraLocNeighborhood; }
			else if ((obj.extraLocCounty != "null") && (obj.extraLocCounty != "") && (typeof(obj.extraLocCounty) != "undefined")) { cityname = obj.extraLocCounty; }
		break;
	}

	// MAIN INFORMATIONS
	if (obj.offline == false) { document.getElementById("city").className = ""; }
	document.getElementById("city").innerHTML = cityname;

	// NO SUNNY DESCRIPTION FOR NIGHT CONDITION
	if ((obj.icon == 32) && (where == "night")) { document.getElementById("desc").innerHTML = WeatherDesc[31]; }
	else if ((obj.icon == 34) && (where == "night")) { document.getElementById("desc").innerHTML = WeatherDesc[33]; }
	else { document.getElementById("desc").innerHTML = WeatherDesc[obj.icon]; }
	document.getElementById("Icon").src = "Images/Icon Sets/Spils/"+AdjustIcon(obj.icon, where)+".png";
   
	// UV INFORMATIONS
	document.getElementById("UVindex").innerHTML = UVIndextext + ((where == "day") ? obj.UVindex + " - " + obj.UVdesc : 0); 

	// TEMP & DEW POINT
	document.getElementById("feelslike").innerHTML = feelsliketext + '<span style= color:' + tempColor(obj.realFeel) + ';>' + obj.realFeel + tempUnit + '</span>';
    document.getElementById("Temp").style.color = tempColor(obj.temp);
    document.getElementById("Temp").innerHTML = obj.temp + tempUnit;
	document.getElementById("dewpt").innerHTML = Dewpointtext + obj.dewpt + tempUnit;
		
	// VISIBILITY & HUMIDITY
	document.getElementById("visibility").innerHTML = visibilitytext  + " " + (Math.round(obj.visibility*convertD*100)/100).toFixed(2) + " " + visibilityunit;
	document.getElementById("humidity").innerHTML = humiditytext + obj.humidity + "%";

	// WINDSPEED & GUST
	if (obj.gust != "") { var gust_tmp = " (" + hightext + Math.round(obj.gust*convertD) + " " + windspeedunit + ")"; } else { var gust_tmp = ""; }
	var windspeed = Math.round(obj.windspeed*convertD);
	if (windspeed == 0) {
		document.getElementById("windspeed").innerHTML = nowindtext;
	} else {
		document.getElementById("windspeed").innerHTML = windtext + obj.cardinal + " - " + windspeed + " " + windspeedunit + gust_tmp;
	}

	// PRESSURE
	if (obj.pressure != "") {
		var pressure = Math.round(obj.pressure*100/convertP)/100;
		document.getElementById("pressure").innerHTML = pressuretext + pressure.toFixed(2) + " " + pressureunit + ((obj.pressuredesc != "") ? " - " + obj.pressuredesc : "");
	} else {
		document.getElementById("pressure").innerHTML = pressuretext + "N/A";
	}

document.getElementById("Day0Hi").innerHTML = "Hi: " + obj.high[0] + "&#176;";

document.getElementById("Day0Lo").innerHTML = "Lo: " + obj.low[0] + "&#176;";

document.getElementById("Day1").innerHTML = days[obj.daydate[1].getDay()];

document.getElementById("Day2").innerHTML = days[obj.daydate[2].getDay()];

document.getElementById("Day3").innerHTML = days[obj.daydate[3].getDay()];

document.getElementById("Day4").innerHTML = days[obj.daydate[4].getDay()];

document.getElementById("Day1Icon").src = "Images/Icon Sets/Spils/" + obj.day_code[1] + ".png";

document.getElementById("Day2Icon").src = "Images/Icon Sets/Spils/" + obj.day_code[2] + ".png";

document.getElementById("Day3Icon").src = "Images/Icon Sets/Spils/" + obj.day_code[3] + ".png";

document.getElementById("Day4Icon").src = "Images/Icon Sets/Spils/" + obj.day_code[4] + ".png";

document.getElementById("Day1HiLo").innerHTML = obj.high[1] + "&#176;/ " + obj.low[1] + "&#176;";

document.getElementById("Day2HiLo").innerHTML = obj.high[2] + "&#176;/ " + obj.low[2] + "&#176;";

document.getElementById("Day3HiLo").innerHTML = obj.high[3] + "&#176;/ " + obj.low[3] + "&#176;";

document.getElementById("Day4HiLo").innerHTML = obj.high[4] + "&#176;/ " + obj.low[4] + "&#176;";


	
	// XML LAST UPDATE
	if (obj.lastupdate.length > 2) {
		document.getElementById("xmlupdate").innerHTML = lastupdatetext + obj.lastupdate[1].split(":")[0]*1 + ":" + obj.lastupdate[1].split(":")[1] + " " + obj.lastupdate[2].toLowerCase();
		} else {
		document.getElementById("xmlupdate").innerHTML = lastupdatetext + obj.lastupdate[1].split(":")[0] + ":" + obj.lastupdate[1].split(":")[1];
	}

	// HOURLY FORECAST
	delelement("HourlyWeatherForecast");
    for (var i=0; i < obj.time24hour.length; i++) {
		var elem = document.createElement("table");
		elem.cellSpacing = 0;
		elem.cellPadding = 0;
		elem.align = "center";
		elem.style.width = "100%";
		elem.style.background = "-webkit-linear-gradient(rgba(0,0,0,0.7), rgba(0,0,0,0.2))";
		elem.style.borderBottom = "2px solid rgba(255,255,255,0.5)";
		elem.style.borderTop = "2px solid rgba(0,0,0,0.5)";
		elem.style.boxShadow = "0px 1px 2px rgba(0,0,0,1)";
		elem.innerHTML = 
			"<tr align='center'>\
				<th>" + TwelveHourForecast(obj.time24hour[i]) + " (" + TranslateDayNight(obj.hwhere[i]).substring(0,1) + ")" + "</th>\
				<td colspan='2' style='width:80%; color:white; font-weight: bold; font-family:SeanHand'>" + WeatherDesc[obj.hcode[i]] + " ("+ TranslatePrecip(obj.hprecip_type[i]) + " " + obj.hpop[i] + "%)" + "</td>\
			</tr>\
			<tr align='center'>\
				<td rowspan='3'><img src='Images/Icon Sets/Yahoo/" + obj.hcode[i] + ".png'/><span style='font-size: 18px; color:" + tempColor(obj.htemp[i]) + "'>" + obj.htemp[i] +  tempUnit + "</span>\</td>\
				<td style='width:40%'>" + windtext + WindDirection(obj.hcardinal[i]) + " (" + obj.hdirection[i] + "&#176;)" + "</td>\
				<td style='width:40%'>" + Math.round(obj.hwindspeed[i]*convertD) + " " + windspeedunit + " (" + hightext.toLowerCase() + Math.round(obj.hgust[i]*convertD) + " " + windspeedunit + ")" + "</td>\
			</tr>\
			<tr align='center'>\
				<td>" + humiditytext.substring(0,3) + ". " + obj.hhumidity[i] +  "%" + "</td>\
				<td>" + Dewpointtext + obj.hdewpt[i] +	tempUnit + "</td>\
			</tr>\
			<tr align='center'>\
				<td>" + visibilitytext.substring(0,3) + ". " + (Math.round(obj.hvisibility[i]*convertD*100)/100).toFixed(2) + " " + visibilityunit + "</td>\
				<td>" + "UV " + obj.hUVindex[i] +  " - " + obj.hUVdesc[i] + "</td>\
			</tr>";
		document.getElementById("HourlyWeatherForecast").appendChild(elem);
		$("#Htemp" + i).css("color", tempColor(obj.htemp[i]));
    }

	// DAY FORECAST
	delelement("DayWeatherForecast");
	for (var i=0; i < obj.daydate.length; i++) {
		var elem = document.createElement("table");
		elem.cellSpacing = 0;
		elem.cellPadding = 0;
		elem.align = "center";
		elem.style.width = "100%";
		elem.style.background = "-webkit-linear-gradient(rgba(0,0,0,0.7), rgba(0,0,0,0.2))";
		elem.style.borderBottom = "2px solid rgba(255,255,255,0.5)";
		elem.style.borderTop = "2px solid rgba(0,0,0,0.5)";
		elem.style.boxShadow = "0px 1px 2px rgba(0,0,0,1)";
		elem.innerHTML = 
			"<tr align='center'>\
				<th style='color: #00FFFF; width:30%'>" + days[obj.daydate[i].getDay()].substring(0,3).toUpperCase() + ". " + ((add_suffix == true) ? Suffix(obj.daydate[i].getDate()) : obj.daydate[i].getDate()) + "</th>\
				<th style='width:35%'>" + TranslateDayNight("D").toUpperCase() + "</th>\
				<th style='width:35%'>" + TranslateDayNight("N").toUpperCase() + "</th>\
			</tr>\
			<tr align='center'>\
				<td><img src='Images/Moonphase/" + obj.night_moondesc[i] + ".png'/></td>\
				<td><img src='Images/Icon Sets/Yahoo/" + AdjustIcon(obj.day_code[i], "day") + ".png'/><span class='FontColorHot'>" + obj.high[i] + tempUnit + "</span></td>\
				<td><img src='Images/Icon Sets/Yahoo/" + AdjustIcon(obj.night_code[i], "night") + ".png'/><span class='FontColorCold'>" + obj.low[i] + tempUnit + "</span></td>\
			</tr>\
			<tr align='center'>\
				<td style='top: -2px; font-weight: bold; font-family:SeanHand'>" + TranslateMoonDesc(obj.night_moondesc[i]) + "</td>\
				<td style='top: -2px; font-weight: bold; font-family:SeanHand'>" + WeatherDesc[obj.day_code[i]] + "</td>\
				<td style='top: -2px; font-weight: bold; font-family:SeanHand'>" + WeatherDesc[obj.night_code[i]] + "</td>\
			</tr>\
			<tr align='center'>\
				<th>" + sunandmoontext + "</th>\
				<td>" + ((ampm == true) ? Convert24To12(obj.sunrise[i]) : obj.sunrise[i] ) + " / " + ((ampm == true) ? Convert24To12(obj.sunset[i]) : obj.sunset[i]) + "</td>\
				<td>" + ((ampm == true) ? Convert24To12(obj.moonrise[i]) : obj.moonrise[i]) + " / " + ((ampm == true) ? Convert24To12(obj.moonset[i]) : obj.moonset[i]) + "</td>\
			</tr>\
			<tr align='center'>\
				<th>" + UVIndextext + "</th>\
				<td>" + obj.day_UVindex[i] + " - " + obj.day_UVdesc[i] + "</td>\
				<td>" + obj.night_UVindex[i] + " - " + obj.night_UVdesc[i] + "</td>\
			</tr>\
			<tr align='center'>\
				<th>" + winddirectiontext + "</th>\
				<td>" + WindDirection(obj.day_cardinal[i]) + " (" + obj.day_direction[i] + "&#176;)</td>\
				<td>" + WindDirection(obj.night_cardinal[i]) + " (" + obj.night_direction[i] + "&#176;)</td>\
			</tr>\
			<tr align='center'>\
				<th>" + windspeedtext + "</th>\
				<td>" + Math.round(obj.day_speed[i]*convertD) + " " + windspeedunit + "</td>\
				<td>" + Math.round(obj.night_speed[i]*convertD) + " " + windspeedunit + "</td>\
			</tr>\
			<tr align='center'>\
				<th>" + humiditytext + "</th>\
				<td>" + obj.day_humidity[i] + "%</td>\
				<td>" + obj.night_humidity[i] + "%</td>\
			</tr>\
			<tr align='center'>\
				<th>" + precipitationtext + "</th>\
				<td>" + TranslatePrecip(obj.day_precip[i]) + " " + obj.day_pop[i] + "%</td>\
				<td>" + TranslatePrecip(obj.night_precip[i]) + " " + obj.night_pop[i] + "%</td>\
			</tr>";
			document.getElementById("DayWeatherForecast").appendChild(elem);
	}
	
	// EXTRA LOCATION
	delelement("ExtraLocation");
	var elem = document.createElement("table");
	elem.cellSpacing = 0;
	elem.cellPadding = 0;
	elem.align = "center";
	elem.style.width = "96%";
	elem.style.marginTop = "5px";
	elem.style.marginBottom = "5px";
	elem.innerHTML = 
		"<tr align='center'>\
			<th>" + nametext + "</th>\
			<td>" + obj.name + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + citytext + "</th>\
			<td>" + obj.extraLocCity + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + neighborhoodtext + "</th>\
			<td>" + obj.extraLocNeighborhood + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + line1text + "</th>\
			<td>" + obj.extraLocLine1 + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + line2text + "</th>\
			<td>" + obj.extraLocLine2 + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + line3text + "</th>\
			<td>" + obj.extraLocLine3 + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + line4text + "</th>\
			<td>" + obj.extraLocLine4 + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + housetext + "</th>\
			<td>" + obj.extraLocHouse + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + streettext + "</th>\
			<td>" + obj.extraLocStreet + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + xstreettext + "</th>\
			<td>" + obj.extraLocXstreet + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + countycodetext + "</th>\
			<td>" + obj.extraLocCounty + " (" + obj.extraLocCountyCode + ")</td>\
		</tr>\
		<tr align='center'>\
			<th>" + statecodetext + "</th>\
			<td>" + obj.extraLocState + " (" + obj.extraLocStateCode + ")</td>\
		</tr>\
		<tr align='center'>\
			<th>" + countrycodetext + "</th>\
			<td>" + obj.extraLocCountry + " (" + obj.extraLocCountryCode + ")</td>\
		</tr>\
		<tr align='center'>\
			<th>" + uziptext + "</th>\
			<td>" + obj.extraLocUzip + "</td>\
		</tr>\
		<tr align='center'>\
			<th>" + postaltext + "</th>\
			<td>" + obj.extraLocPostal + "</td>\
		</tr>\
		<tr align='center'>\
			<th>Woeid</th>\
			<td>" + obj.woeid + "</td>\
		</tr>";
	document.getElementById("ExtraLocation").appendChild(elem);
	
	document.getElementById("Layer").style.backgroundImage = "url('Images/Layer/" + where + ".jpg')";
}

function tempColor(temp) {
	if (obj.celsius == "YES") {
		if (temp <= 8) { var color = "#80d0d0"; }
		else if (temp >= 9 && temp <= 15) { var color = "#fdee00"; }
		else if (temp >= 16 && temp <= 22) { var color = "#7eff00"; }
		else if (temp >= 23 && temp <= 27) { var color = "#ffad11"; }
		else  { var color = "#ff4f32"; }
	} else {
		if (temp <= 46) { var color = "#f79e0b"; }
		else if (temp >= 47 && temp <= 59) { var color = "#f79e0b"; }
		else if (temp >= 60 && temp <= 71) { var color = "#f79e0b"; }
		else if (temp >= 72 && temp <= 80) { var color = "#f79e0b"; }
		else  { var color = "#566777"; }
	}
	return color
}

function updateWeather_XML() {
	var files = "widgetweather" + xmlnumber + ".xml";
	
	switch (GroovyPlus) { /* Dual purpose switch by GroovyCarrot, NewD & Chevy */
		case true: 
			groovyAPI.do ({ read: files }, function(data) { weatherHandler(data);
			}).fail( function () {
				document.getElementById("desc").innerHTML = "No widgetweather.xml file !"; 
			});
		break;
		case false: 
			if (XML_TEST == true) { url = files; } else { url = "file:///private/var/mobile/Documents/" + files; }
			jQuery.get(url, function(data) { weatherHandler(data);
			}).fail( function () {
				document.getElementById("desc").innerHTML = "No widgetweather.xml file !"; 
			}); 
		break;
	} 
	
	// REINITIALIZE THE TIMER TO NOT LAUNCH MULTIPLE INSTANCES OF THE FUNCTION	
	clearTimeout(refreshTimer); 
	refreshTimer = setTimeout(updateWeather_XML, 30*1000);
} 

//PARSE ALL WEATHER INFORMATION
function weatherHandler(data) {
	
	obj.updatetimestring = $(data).find('updatetimestring').text();
	
	if (updateFileTimer != obj.updatetimestring) {
		data = data.replace(/null/g,"");
		updateFileTimer = obj.updatetimestring;
		obj.lastupdate = obj.updatetimestring.split(" ");

		// WIDGET WEATHER SETTINGS
		obj.location = [99]; // FAKE NUMBER FOR CURRENT LOCATION
		$(data).find('settings').each( function() {
			obj.interval = $(this).find('interval').text();
			obj.timehour = $(this).find('timehour').text();
			obj.autogpsupdate = $(this).find('autogpsupdate').text();
			obj.location[1] = $(this).find('location1').text()*1;
			obj.location[2] = $(this).find('location2').text()*2;
			obj.location[3] = $(this).find('location3').text()*3;
			obj.location[4] = $(this).find('location4').text()*4;
			obj.location[5] = $(this).find('location5').text()*5;
			ampm = (obj.timehour == "24h") ? false : true;
		});
		
		// REDUCE THE ARRAY TO KEEP ONLY VALID XML OPTIONS (REMOVE NULL, NAN AND ZERO VALUES)
		obj.location = jQuery.grep(obj.location, function(val) {
			if (isNaN(val) || val == 0 || val == "") { return false; }
			return true;
		});
		obj.location[0] = ""; // REMOVE THE FAKE NUMBER
		for (var i=1; i < obj.location.length; i++) { obj.location[i] = "-" +  obj.location[i]; }
		
		// CURRENT WEATHER CONDITION
		$(data).find('currentcondition').each( function() {
			obj.name = $(this).find('name').text();
			obj.city = $(this).find('city').text();
			obj.woeid = $(this).find('woeid').text();
			obj.transactionid = $(this).find('transactionid').text();	
			obj.locationid = $(this).find('locationid').text();	
			obj.icon = $(this).find('code').text();
			obj.desc = $(this).find('description').text();
			obj.observationtime = $(this).find('observationtime').text();
			obj.timezone = $(this).find('timezone').text().replace("GMT","")*1;
			obj.moondesc = $(this).find('moonphase').text();
			obj.celsius = $(this).find('celsius').text();
			obj.pressure = $(this).find('pressure').text();
			obj.rising = $(this).find('rising').text();
			obj.pressuredesc = $(this).find('pressuredesc').text(); 		
			obj.humidity = $(this).find('humidity').text(); 
			obj.visibility = $(this).find('visibility').text();
			obj.cardinal = $(this).find('cardinal').text();
			obj.direction = $(this).find('direction').text()*1;
			obj.windspeed = $(this).find('speed').text();
			obj.gust = $(this).find('gust').text();
			obj.UVdesc = $(this).find('uvdesc').text();
			obj.UVindex = $(this).find('uvindex').text();
			obj.unitsdistance = $(this).find('unitsdistance').text();
			obj.unitspressure = $(this).find('unitspressure').text();
			obj.unitsspeed = $(this).find('unitsspeed').text();
			obj.unitstemperature = $(this).find('unitstemperature').text();
			obj.extraLocLine1 = $(this).find('extraLocLine1').text();
			obj.extraLocLine2 = $(this).find('extraLocLine2').text();
			obj.extraLocLine3 = $(this).find('extraLocLine3').text();
			obj.extraLocLine4 = $(this).find('extraLocLine4').text();			
			obj.extraLocHouse = $(this).find('extraLocHouse').text();
			obj.extraLocStreet = $(this).find('extraLocStreet').text();
			obj.extraLocXstreet = $(this).find('extraLocXstreet').text();	
			obj.extraLocName = $(this).find('extraLocName').text().replace(" ","");
			obj.extraLocPostal = $(this).find('extraLocPostal').text();
			obj.extraLocCity = $(this).find('extraLocCity').text();
			obj.extraLocNeighborhood = $(this).find('extraLocNeighborhood').text();
			obj.extraLocCounty = $(this).find('extraLocCounty').text();
			obj.extraLocCountyCode = $(this).find('extraLocCountyCode').text();
			obj.extraLocState = $(this).find('extraLocState').text();
			obj.extraLocStateCode = $(this).find('extraLocStateCode').text();
			obj.extraLocCountry = $(this).find('extraLocCountry').text();
			obj.extraLocCountryCode = $(this).find('extraLocCountryCode').text();
			obj.extraLocUzip = $(this).find('extraLocUzip').text();
			obj.latitude = obj.extraLocName.split(",")[0]*1;
			obj.longitude = obj.extraLocName.split(",")[1]*1;
			obj.temp = $(this).find('temp').text()*1;
			obj.realFeel = ($(this).find('chill').text() == "") ? obj.temp : $(this).find('chill').text()*1;
			obj.dewpt = $(this).find('dewpt').text()*1;
			Distance_In_Miles = (obj.unitsdistance == "km") ? false : true;
			Inches_Of_Mercury = (obj.unitspressure == "mb") ? false : true;
		});
		
		// LOOK FOR UTC/GMT CORRECTION AND FORCE THE CLOCK TO UPDATE
		UTC = obj.timezone + currentTime.getTimezoneOffset()/60;
		updateClock();
		
		// DAY WEATHER FORECAST
		obj.dayofweek = [];
		obj.daydate = [];
		obj.sunrise = [];
		obj.sunset = [];
		obj.day_desc = [];
		obj.day_code = [];
		obj.day_pop = [];
		obj.day_precip = [];
		obj.day_humidity = [];
		obj.day_UVindex = [];
		obj.day_UVdesc = [];
		obj.day_direction = [];
		obj.day_speed = [];
		obj.day_cardinal = [];
		obj.high = [];
		obj.low = [];
		$(data).find('day').each( function(i, item) {
			obj.day_code[i] = $(this).find('code').text();
			obj.day_pop[i] = $(this).find('pop').text();
			obj.dayofweek[i] = $(this).find('dayofweek').text();
			obj.daydate[i] = new Date($(this).find('daydate').text()*1000);
			obj.sunrise[i] = ConvertHours($(this).find('sunrise').text());
			obj.sunset[i] = ConvertHours($(this).find('sunset').text());
			obj.day_desc[i] = $(this).find('description').text();		
			obj.day_precip[i] = $(this).find('typeofprecipitation').text();
			obj.day_humidity[i] = $(this).find('humidity').text();
			obj.day_cardinal[i] = $(this).find('cardinal').text();
			obj.day_direction[i] = $(this).find('direction').text();
			obj.day_speed[i] = $(this).find('speed').text();			
			obj.day_UVdesc[i] = $(this).find('uvdesc').text();
			obj.day_UVindex[i] = $(this).find('uvindex').text();		
			obj.high[i] = ($(this).find('high').text() == "") ? "null" : $(this).find('high').text()*1;
			obj.low[i] = $(this).find('low').text()*1;		
		});
		
		// NIGHT WEATHER CONDITION
		obj.moonrise = [];
		obj.moonset = [];
		obj.night_desc = [];
		obj.night_code = [];		
		obj.night_pop = [];
		obj.night_precip = [];
		obj.night_humidity = [];
		obj.night_UVindex = [];
		obj.night_UVdesc = [];
		obj.night_direction = [];
		obj.night_speed = [];
		obj.night_cardinal = [];
		obj.night_moondesc = [];
		$(data).find('night').each( function(i, item) {
			obj.night_moondesc[i] = $(this).find('moonphase').text();
			obj.moonrise[i] = ($(this).find('moonrise').text() != "") ? ConvertHours($(this).find('moonrise').text()) : "--:--";
			obj.moonset[i] = ($(this).find('moonset').text() != "") ? ConvertHours($(this).find('moonset').text()) : "--:--";	
			obj.night_code[i] = $(this).find('code').text();
			obj.night_pop[i] = $(this).find('pop').text();
			obj.night_desc[i] = $(this).find('description').text(); 	
			obj.night_precip[i] = $(this).find('typeofprecipitation').text();
			obj.night_humidity[i] = $(this).find('humidity').text();
			obj.night_cardinal[i] = $(this).find('cardinal').text();
			obj.night_direction[i] = $(this).find('direction').text();
			obj.night_speed[i] = $(this).find('speed').text();			
			obj.night_UVdesc[i] = $(this).find('uvdesc').text();
			obj.night_UVindex[i] = $(this).find('uvindex').text();		
		});
		
		// HOURLY WEATHER FORECAST
		obj.hwhere = [];
		obj.time24hour = [];
		obj.hday = [];
		obj.hcode = [];
		obj.hpop = [];
		obj.hdewpt = [];
		obj.htemp = [];
		obj.hgust = [];
		obj.hvisibility = [];
		obj.hwindspeed = [];
		obj.hdesc = [];
		obj.hprecip_type = [];	
		obj.hhumidity = [];
		obj.hUVdesc = [];				
		obj.hUVindex = [];
		obj.hdirection = [];
		obj.hcardinal = [];
		$(data).find('hour').each( function(i, item) {
			obj.hwhere[i] = $(this).find('condition').text();
			obj.hday[i] = $(this).find('dayofweek').text();
			obj.time24hour[i] = ConvertHours($(this).find('time24hour').text());
			obj.hcode[i] = $(this).find('code').text();
			obj.hdesc[i] = $(this).find('description').text();
			obj.hprecip_type[i] = $(this).find('typeofprecipitation').text();
			obj.hpop[i] = $(this).find('percentprecipitation').text();
			obj.hcardinal[i] = $(this).find('cardinal').text();					
			obj.hdirection[i] = $(this).find('direction').text();
			obj.hhumidity[i] = $(this).find('humidity').text();					
			obj.hUVdesc[i] = $(this).find('uvdesc').text(); 
			obj.hUVindex[i] = $(this).find('uvindex').text();					
			obj.hdewpt[i] = $(this).find('dewpt').text();
			obj.hwindspeed[i] = $(this).find('speed').text();					
			obj.hgust[i] = $(this).find('gust').text();
			obj.hvisibility[i] = $(this).find('visibility').text();
			obj.htemp[i] = $(this).find('temp').text()*1;
		});
		
		// UPDATE TIME
		if (ampm == true) {
			updateTimer = new Date([obj.lastupdate[0].split('-')[1], obj.lastupdate[0].split('-')[2], obj.lastupdate[0].split('-')[0]].join('/') + " " + obj.lastupdate[1] + " " + obj.lastupdate[2]);
		} else {
			updateTimer = new Date([obj.lastupdate[0].split('-')[1], obj.lastupdate[0].split('-')[2], obj.lastupdate[0].split('-')[0]].join('/') + " " + obj.lastupdate[1]);
		}
		
		// CHECK IF ONLINE OR OFFLINE
		if ( currentTime.getTime() - UTC*3600*1000 - updateTimer.getTime() > obj.interval*60*1000 ) {
			obj.offline = true;
			document.getElementById("city").className = "FontColorRed";
		} else {
			obj.offline = false;
		}
		
		//INITIALIZE PAGES AT FIRST START
		if (dayhour == null && obj.location.length > 1) { StartLocationTouch(); }
		
		// WORKAROUND FOR DAY0 NOT PRESENT AFTER SUNSET - REPLACE THE DEFAULT NIGHT VALUES
		if (obj.day_code[0] == "") {
			obj.day_desc[0] = "--";
			obj.day_code[0] = 3200;
			obj.day_pop[0] = "--";
			obj.day_UVindex[0] = "--";
			obj.day_UVdesc[0] = "--";
			obj.day_direction[0] = "--";
			obj.day_cardinal[0] = "--";
			obj.day_speed[0] = 0;
			obj.day_precip[0] = "--";
			obj.day_humidity[0] = "--";
		}
		
		// WORKAROUND FOR NULL TEMP
		if (obj.high[0] == "null") { obj.high[0] = "--"; }
			
		// WORKAROUND FOR CURRENT CODE IS NULL
		if (obj.icon == "" || obj.icon == 3200) {
			obj.icon = obj.hcode[0];
			obj.desc = obj.hdesc[0];
		}
		
		// WORKAROUND FOR VISIBILITY
		if (obj.visibility == "" ) { obj.visibility = obj.hvisibility[0]; }	
	
		dealWithWeather(obj);	
	} else {
		// CHECK IF ONLINE OR OFFLINE
		if ( currentTime.getTime() - UTC*3600*1000 - updateTimer.getTime() > obj.interval*60*1000 ) {
			obj.offline = true;
			document.getElementById("city").className = "FontColorRed";
		}
		
		// CONDITION CHANGE
		CheckCondition();
	}
} //end of weather handler variable


// CHECK DAY OR NIGHT
function CheckCondition() {
	var whereTmp = where;
	if (dayhour != null) {
		if ((time_to_change_wall < dayhour) || (time_to_change_wall >= nighthour)) { whereTmp = "night"; } else { whereTmp = "day"; }
	}
	if (whereTmp != where) { dealWithWeather(obj); }
}

function ConvertHours(isostr) {
	var parts = isostr.split(":");
	return hmstring(parts[0]*1 + parts[1]/60 + GMT);
}

function hmstring(hours) {
  if (hours >= 24) { hours = hours - 24; }
  if (hours < 0) { hours = hours + 24; }
  var mins = Math.round((hours - Math.floor(hours)) * 60);
  var hours = Math.floor(hours);
  if (mins >= 60) {
	mins = mins - 60;
	hours = (hours + 1 >= 24) ? hours - 23 : hours + 1;
  }
  mins = (mins < 10) ? "0" + mins : mins;
  hours = (hours < 10) ? "0" + hours : hours;
  return hours + ":" + mins;
}

function dateFromISO8601(isostr) {
	var parts = isostr.match(/\d+/g);
	return new Date(parts[0], parts[1] - 1, parts[2], parts[3], parts[4], parts[5]);
}

function ConvertToAmPm(timestamp) {
	var updateTimeHours = timestamp.getHours();
	var updateTimeMinutes = timestamp.getMinutes() < 10 ? '0' + timestamp.getMinutes() : timestamp.getMinutes();
	var updateTimeOfDay = ( updateTimeHours < 12 ) ? "am" : "pm";

	if (ampm == false) {
		updateTimeHours = ( updateTimeHours < 10 ? "0" : "" ) + updateTimeHours;
		var updateString = updateTimeHours + ":" + updateTimeMinutes;
	} else {
		updateTimeHours = ( updateTimeHours > 12 ) ? updateTimeHours - 12 : updateTimeHours;
		updateTimeHours = ( updateTimeHours == 0 ) ? 12 : updateTimeHours;
		var updateString = updateTimeHours + ":" + updateTimeMinutes + " " + updateTimeOfDay;
	}
	return updateString;
}

function Convert24To12(hour) {
	var updateTimeHours = hour.split(":")[0]*1;
	if (!isNaN(updateTimeHours)) {
		var updateTimeOfDay = ( updateTimeHours < 12 ) ? "am" : "pm";
		updateTimeHours = ( updateTimeHours > 12 ) ? updateTimeHours - 12 : updateTimeHours;
		updateTimeHours = ( updateTimeHours == 0 ) ? 12 : updateTimeHours;
		var updateString = updateTimeHours + ":" + hour.split(":")[1] + " " + updateTimeOfDay;
		return updateString;
	} else {
		return hour;
	}
}

function TwelveHourForecast(hour) {
	if (ampm == true) {
		hour = parseInt(hour.split(':')[0]);
		var timeOfhour = ( hour < 12 ) ? "AM" : "PM";
		hour = ( hour > 12 ) ? hour - 12 : hour;
		hour = ( hour == 0 ) ? 12 : hour;
		hour = hour + " " + timeOfhour;
	}
	return hour;
}

function AdjustIcon(icon, whereTmp) {
	switch(whereTmp) {
		case "day":
			if (icon == 27) { icon = 28; }
			if (icon == 29) { icon = 30; }	
			if (icon == 31) { icon = 32; }	
			if (icon == 33) { icon = 34; }
			if (icon == 39) { icon = 38; }
		break;
		case "night":
			if (icon == 28) { icon = 27; }
			if (icon == 30) { icon = 29; }	
			if (icon == 32) { icon = 31; }	
			if (icon == 34) { icon = 33; }
			if (icon == 38) { icon = 39; }
		break;
	}
	return icon;
}

function dayofweektonumber(dayofweek) {
	switch (dayofweek) {
		case "Sun": { return 1; }
		case "Mon": { return 2; }
		case "Tue":	{ return 3; }
		case "Wed":	{ return 4; }
		case "Thu":	{ return 5; }
		case "Fri":	{ return 6; }
		case "Sat":	{ return 7; }
	}
}

function delelement(elem) {
	var element = document.getElementById(elem);
	while (element.firstChild) { element.removeChild(element.firstChild); }
}
